Ruby - Bug #6571

Time.mktime Y2K38 problem on 1.9.3p125 i386-mingw32
06/11/2012 01:21 AM - MartinBosslet (Martin Bosslet)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 1.9.3p125 (2012-02-16) Backport:
[(386-mingw32]

Description

=begin
This came up in https:/bugs.ruby-lang.org/issues/6122.

(({Time.mktime(2038, 1, 19, 11, 14, 8)})) failed. To my understanding, 32 bit Time
issues shouldn't occur in 1.9.3? I'm assigning this to Luis, maybe he knows
about this and what to do? Please feel free to reassign back to me.

=end

Related issues:
Related to Ruby - Bug #6122: OpenSSL::PKCS7 verify Closed 03/07/2012

Associated revisions

Revision 3333b6b7adbef88be02340f763b97e0e4a2b948b - 05/30/2016 01:02 PM - rhenium (Kazuki Yamaguchi)
openssl: use NUM2TIMET() to convert Integer to time_t

e ext/openssl/ossl_asni.c (time_to_time_t): Use NUM2TIMET() instead of
NUM2LONG(). time_t may be larger than long.
[ruby-core:45552] [Bug #6571]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55219 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 3333b6b7 - 05/30/2016 01:02 PM - rhenium (Kazuki Yamaguchi)
openssl: use NUM2TIMET() to convert Integer to time_t
e ext/openssl/ossl_asni.c (time_to_time_t): Use NUM2TIMET() instead of
NUM2LONG(). time_t may be larger than long.
[ruby-core:45552] [Bug #6571]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55219 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 1978ce784b44e9e0ff376779629714cbad3dd756 - 05/31/2016 02:10 PM - rhenium (Kazuki Yamaguchi)
openssl: add missing test for r55219
e test/openssl/test_asn1.rb: Add missing regression test for r55219. It
fixed the year 2038 issue but the test code was missing.
[ruby-core:45552] [Bug #6571]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55229 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 1978ce78 - 05/31/2016 02:10 PM - rhenium (Kazuki Yamaguchi)
openssl: add missing test for r55219
e test/openssl/test_asn1.rb: Add missing regression test for r55219. It
fixed the year 2038 issue but the test code was missing.
[ruby-core:45552] [Bug #6571]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55229 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9eca2ced64b19f2d222937edc4ea78e7a1d31b32 - 06/01/2016 12:41 PM - rhenium (Kazuki Yamaguchi)
openssl: fix the Year 2038 problem
r55219 didn't fix the entire issue. It only fixed the issue on
environment with sizeof(time_t) == 8 && sizeof(long) ==

e ext/openssl/extconf.rb: Check existence of ASN1_TIME_adj(). The old
ASN1_TIME_set() is not Year 2038 ready on sizeof(time_t) ==
environment. This function was added in OpenSSL 1.0.0.
[ruby-core:45552] [Bug #6571]

ext/openssl/ossl_asni.c (ossl_time_split): Added. Split the argument
(Time) into the number of days elapsed since the epoch and the
remainder seconds to conform to ASN1_TIME_adj().
(obj_to_asntutime, obj_to_asnigtime): Use ossl_time_split() and
ASN1_*TIME_adj().

ext/openssl/ossl_asni.h: Add the function prototype for
ossl_time_split().

ext/openssl/ossl_x509.[ch]: Add ossl|_x509_time_adjust(). Similarly to
obj_to_asn1*time(), use X509_time_adj_ex() instead of X509_time_adj().

ext/openssl/ossl_x509cert.c, ext/openssl/ossl_x509crl.c,
ext/openssl/ossl_x509revoked.c: Use ossl_x509_time_adjust().

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55249 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 9eca2ced - 06/01/2016 12:41 PM - rhenium (Kazuki Yamaguchi)
openssil: fix the Year 2038 problem

r55219 didn't fix the entire issue. It only fixed the issue on
environment with sizeof(time_t) == 8 && sizeof(long) == 4.

e ext/openssl/extconf.rb: Check existence of ASN1_TIME_adj(). The old
ASN1_TIME_set() is not Year 2038 ready on sizeof(time_t) ==
environment. This function was added in OpenSSL 1.0.0.
[ruby-core:45552] [Bug #6571]

ext/openssl/ossl_asn1.c (ossl_time_split): Added. Split the argument
(Time) into the number of days elapsed since the epoch and the
remainder seconds to conform to ASN1_TIME_adj().
(obj_to_asn1iutime, obj_to_asnigtime): Use ossl_time_split() and
ASN1_*TIME_adj().

ext/openssl/ossl_asn1.h: Add the function prototype for
ossl_time_split().

ext/openssl/ossl_x509.[ch]: Add ossl_x509_time_adjust(). Similarly to
obj_to_asn1*time(), use X509_time_adj_ex() instead of X509_time_adj().

ext/openssl/ossl_x509cert.c, ext/openssl/oss|_x509crl.c,
ext/openssl/ossl_x509revoked.c: Use ossl_x509_time_adjust().

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@55249 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 06/11/2012 01:52 PM - nobu (Nobuyoshi Nakada)
- Description updated

- Status changed from Assigned to Feedback

- Target version changed from 2.0.0 to 1.9.3

| can't reproduce it with 1.9.3p216, in JST and PST.
What are the failure message and your timezone?

#2 - 06/11/2012 01:53 PM - akr (Akira Tanaka)
2012/6/11 MartinBosslet (Martin Bosslet) Martin.Bosslet@googlemail.com:

Time.mktime(2038, 1, 19, 11, 14, 8) failed. To my understanding, 32 bit Time
issues shouldn't occur in 1.9.3? I'm assigning this to Luis, maybe he knows
about this and what to do? Please feel free to reassign back to me.
| couldn't reproduce the problem on GNU/Linux (x86_64 and i686).

% ./ruby -ve 'Time.mktime(2038, 1, 19, 11, 14, 8)'
ruby 2.0.0dev (2012-06-11 trunk 36028) [x86_64-linux]

% ./ruby -ve 'Time.mktime(2038, 1, 19, 11, 14, 8)'
ruby 2.0.0dev (2012-06-11 trunk 36030) [i686-linux]

So it seems platform dependent issue.

However | think you should show the actual result (failure message) and
your timezone, though.

Note that my timzone is +0900 (JST).

Tanaka Akira

#3 - 06/11/2012 02:20 PM - phasis68 (Heesob Park)
| guess it is not an issue of Time#mktime but an issue of OpenSSL.
Furthermore, the description is inaccurate.

Here is my test with ruby 1.9.3p194 (2012-04-20) [i386-mingw32]
C:\Ruby193\bin>irb

irb(main):001:0> require 'OpenSSL'

=> true

irb(main):002:0> cert = OpenSSL::X509::Certificate.new

=> #<OpenSSL::X509::Certificate subject=, issuer=, serial=0, not_before=nil, not_after=nil>
irb(main):003:0> cert.not_after = Time.mktime(2038, 1, 19, 12, 14, 7)

=> 2038-01-19 12:14:07 +0900

irb(main):004:0> cert.not_after = Time.mktime(2038, 1, 19, 12, 14, 8)
RangeError: bignum too big to convert into long' from (irb):4:in not_after='
from (irb):4

from C:/Ruby193/bin/irb:12:in ™

| think that this error due to time_to_time_t function defined in ext/openssl/ossl_asni.c

time_t
time_to_time_t(VALUE time)

{
return (time_t)NUM2LONG(rb_Integer(time));

}

#4 - 06/11/2012 02:32 PM - nobu (Nobuyoshi Nakada)
- Status changed from Feedback to Assigned
- Assignee changed from luislavena (Luis Lavena) to MartinBosslet (Martin Bosslet)

- Target version changed from 1.9.3 to 2.0.0

#5 - 06/12/2012 09:12 AM - MartinBosslet (Martin Bosslet)

- Category changed from core to ext

Thanks for your analysis, guys. Makes sense now, why | couldn't reproduce it on 64 bits. The original #6122 did not contain the actual error that was
raised, so thanks Heesob for pointing me towards the solution!

#6 - 12/06/2012 05:16 PM - mghomn (Justin Peal)

Great thanks to all of you.

#7 - 02/18/2013 09:51 PM - mame (Yusuke Endoh)

- Target version changed from 2.0.0 to 2.6

#8 - 09/13/2015 03:16 AM - zzak (zzak _)
- Assignee changed from MartinBosslet (Martin Bosslet) to 7150

#9 - 05/30/2016 01:02 PM - Anonymous

- Status changed from Assigned to Closed
Applied in changeset r55219.

openssl: use NUM2TIMET() to convert Integer to time_t

e ext/openssl/ossl_asni.c (time_to_time_t): Use NUM2TIMET() instead of
NUM2LONG(). time_t may be larger than long.
[ruby-core:45552] [Bug #6571]

06/11/2025

/4


bugs.ruby-lang.org/issues/6571
https://bugs.ruby-lang.org/issues/6571
http://www.tcpdf.org

